package edu.jt_kb.cs4308.compiler.models;

public enum TokenType {
    INT_LIT(10),IDENT(11),ASSIGN_OP(20),ADD_OP(21),SUB_OP(22),MULT_OP(23),
    DIV_OP(24),LEFT_PAREN(26),RIGHT_PAREN(27),SEMI_COLON(28), STRING_LITERAL(29),
    COMMA(30), LEFT_CURLY(31), RIGHT_CURLY(32), LEFT_SQUARE(33), RIGHT_SQUARE(34),
    RESERVED_WORD(35),EOF(-1),UNKNOWN(-2);


    public final int value; /* represents which Token you are referencing. */

    /**
     * Constructor for the ENUM to represent the value of each Token.
     *
     * @precondition: none
     * @postcondition: A token is created.
     *
     * @param value - the integer value for the token.
     */
    TokenType(int value) {
        this.value = value;
    }

    /**
     * Compares two tokens and returns whether they are the same value or not.
     *
     * @param other - the other token being compared.
     * @return if the values are the same,  true
     *         else,                        false
     */
    public boolean equals(TokenType other) {
        return this.value == other.value;
    }
}
